from common import Common
from common.sql_help import sqlCollect


class SPHLS:

    @classmethod
    def get_sphls_data(cls, task_mark, url, number, mark):
        data_list = sqlCollect.sph_data_info_list(url)
        list = []
        if data_list:
            for data in data_list:
                video_id = data[0]
                status = sqlCollect.is_used(task_mark,video_id, mark, "视频号历史")
                if status:
                    old_title = data[1]
                    share_cnt = int(data[2])
                    like_cnt = int(data[3])
                    oss_url = data[4]
                    oss_cover = data[5]
                    duration = int(float(data[6]))
                    Common.logger("sph-ls").info(
                        f"扫描：{task_mark},用户主页id:{url},视频id{video_id} ,分享:{share_cnt},点赞:{like_cnt},时长:{duration}")
                    if share_cnt < 300 or share_cnt < like_cnt or duration < 30 or duration > 720:
                        Common.logger("sph-ls").info(
                            f"任务：{task_mark},用户主页id:{url},视频id{video_id} ,分享:{share_cnt},点赞:{like_cnt} ,时长:{duration} ")
                        continue

                    all_data = {"video_id": video_id, "cover": oss_cover, "video_url": oss_url, "rule": '',
                                "old_title": old_title}
                    list.append(all_data)
                    if len(list) == int(number):
                        Common.logger("sph-ls").info(f"获取视频号视频总数:{len(list)}\n")
                        return list
            return list
        else:
            Common.logger("sph-ls").info(f"{url}无数据\n")
            return None






if __name__ == '__main__':
    SPHLS.get_sphls_data(1,2,3,4)