import time

import requests
import json

from common import Feishu
from common.sql_help import sqlCollect


class DYNrxs:
    """
    抖音内容相似
    """
    @classmethod
    def get_dy_nrxs(cls):
        user = sqlCollect.get_machine_making_reflux("抖音", "抖音历史")
        if user == None:
            return
        user = [item[0] for item in user]
        for uid in user:
            url = "http://8.217.190.241:8888/crawler/dou_yin/recommend_user"

            payload = json.dumps({
                "account_id": uid,
                "cursor": ""
            })
            headers = {
                'Content-Type': 'application/json'
            }

            response = requests.request("POST", url, headers=headers, data=payload)
            response = response.json()
            code = response['code']
            if code == 0:
                data_list = response['data']['data']
                if data_list == []:
                    sqlCollect.update_machine_making_reflux(uid)
                    continue
                sqlCollect.update_machine_making_reflux(uid)
                list = []
                for data in data_list:
                    name = data['nickname']
                    sec_uid = data['sec_uid']
                    time.sleep(1)
                    values = [
                        [
                            uid,
                            name,
                            sec_uid
                        ]
                    ]
                    Feishu.insert_columns("AIW2sNNjdhCgT3tug7sco7FGnse", 'GO3Abg', "ROWS", 1, 2)
                    time.sleep(0.5)
                    Feishu.update_values("AIW2sNNjdhCgT3tug7sco7FGnse", 'GO3Abg', "A2:Z2", values)
                    list.append(sec_uid)
                if list:
                    result = ','.join(list)
                    values = [
                        [
                            "抖音",
                            result,
                            "72804451",
                            "5",
                            "通用-安全分享",
                            "AI片尾引导",
                            "",
                            "",
                            "AI标题",
                            "3",
                            f"溯源账号:{uid}"
                        ]
                    ]
                    Feishu.insert_columns("WGIYsSDdxhItBwtJ0xgc0yE7nEg", '0701bd', "ROWS", 1, 2)
                    time.sleep(0.5)
                    Feishu.update_values("WGIYsSDdxhItBwtJ0xgc0yE7nEg", '0701bd', "B2:Z2", values)
            else:
                Feishu.finish_bot("dou_yin/recommend_user 请求失败",
                                  "https://open.feishu.cn/open-apis/bot/v2/hook/575ca6a1-84b4-4a2f-983b-1d178e7b16eb",
                                  "【抖音接口使用提示】")



if __name__ == '__main__':
    DYNrxs.get_dy_nrxs()